#include "AviHeader.h"
#include "AviSocket.h"
#include <malloc.h>
#include <signal.h>
#include <stdio.h>
#include <pthread.h>

void * answer_query_from_client(void * arg);

int main( int argc, char ** argv ){
	if( argc < 2){
		printf("Usage: netAviServer <port_number>");
		exit(1);
	}
	int port_number;
	sscanf(argv[1], "%d", &port_number);
	
	WSADATA wsaData;
	if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) /* Load Winsock 2.0 DLL */
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

	AviSocket * server_socket = new AviSocket(port_number, "");

	pthread_attr_t thread_attr;
	pthread_attr_init(&thread_attr);
	pthread_attr_setdetachstate(&thread_attr, PTHREAD_CREATE_DETACHED);

	while(1){
		fprintf(stderr,"Waiting for client\n");
		if( server_socket -> server_wait_for_client() ){
			AviSocket * new_client_socket = new AviSocket(server_socket);

			pthread_t cur_thread;
			pthread_create(&cur_thread, &thread_attr,
					answer_query_from_client, (void *)new_client_socket);
			//answer_query_from_client((void*)new_client_socket);
		}
	}
}

void client_done(AviSocket * server_socket, AviHeader * avi_helper){	
	server_socket -> close_socket(); //Closes the client socket
	delete avi_helper;
	delete server_socket;
}

void * answer_query_from_client(void * arg){
	AviSocket * server_socket = (AviSocket*)arg;
	char avi_filename[1000];
	if( server_socket -> read_filename_from_socket(avi_filename) == 0){
		fprintf(stderr,"%s:%d Unable to read filename from client\n", __FILE__, __LINE__);
		return NULL;
	}
	AviHeader * avi_helper = new AviHeader(avi_filename, PPM_FORMAT_PIXMAP);
	if( !avi_helper -> setupGrabberGraphResult ){
		fprintf(stderr,"%s:%d Aviopen failed on %s\n", __FILE__, __LINE__, avi_filename);
		server_socket -> write_empty_to_socket();
		client_done(server_socket, avi_helper);	
		return NULL;
	}
	server_socket -> write_aviinfo_to_socket(
			avi_helper -> width, avi_helper -> height, avi_helper -> num_frames,
			avi_helper -> frame_rate, 0);

	int frame_number = 0;
	double frame_time;
	while(1){
		if( server_socket -> read_framenumber_from_socket(frame_number) == 0 ||
				frame_number < 0 ){
			client_done(server_socket, avi_helper);	
			return NULL;
		}
		avi_helper -> getFrame(frame_number);
		//fprintf(stderr,"%s:%d %d %d %d\n", __FILE__, __LINE__, pixmap[0], pixmap[1], pixmap[2]);
		server_socket -> write_frame_to_socket(avi_helper ->width, avi_helper ->height,
				avi_helper -> pixmap);
	}
}

